//仅支持单个文件上传
function random_string(len) {
    len = len || 32;
    var chars = "ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678";
    var maxPos = chars.length;
    var pwd = "";
    for (let i = 0; i < len; i++) {
        pwd += chars.charAt(Math.floor(Math.random() * maxPos));
    }
    return pwd;
};
function _OSS(region, accessKeyId, accessKeySecret, bucket, ossDir) {
    this.ossDir = ossDir;
    this.client = new OSS.Wrapper({
        region,
        //云账号AccessKey有所有API访问权限，建议遵循阿里云安全最佳实践，部署在服务端使用RAM子账号或STS，部署在客户端使用STS。
        accessKeyId,
        accessKeySecret,
        bucket,
        secure: true
    });
}
_OSS.prototype.ossUpload = function (files, callback, progress) {
    // if (files.target.files.length<1) {
        // callback('not file');
        // return
    // }
    var file = files; //获取要上传的文件对象
    var fileName = Date.parse(new Date());
    var fileExt = file.name
        .toLowerCase()
        .split(".")
        .splice(-1);
    var randStr = random_string(6);
    var newFilename = fileName + "-" + randStr + "." + fileExt[0];

    this.client
        .multipartUpload(this.ossDir + "/" + newFilename, file, {
            progress: p => { //p百分比 0~1
                return done => {
                    if (progress) {
                        progress(p);
                    }
                    done();
                }
            }
        })
        .then(function (result) {
            callback(result);
        })
        .catch(function (err) {
            callback(err);
        });
}

export default _OSS